% close all; clc; clear all;
load AB_passiveloss;
load AB_driverPA_440mA;

desFreq = 2.35;
freqs = [2.3:0.05:2.5]';
[dummy freqIdx] = min((freqs-desFreq).^2);
% [dummy voltIdx] = min((vd-desVolt).^2);

load AB_PA_160ma_freqs;

CircLoss = 0.48; %Not used, circulator incorporated in driver ouput.
fsq_dev = 0.2; % FSQ off by 0.2 dB
OutputLoss = [20.6995, 20.7735, 20.7458, 20.7975, 20.8208] + fsq_dev-0.04;%passive loss adjusted for FSQ deviation and SMU deviation



% measIdx = 2;
D_OutputPower = Driver_OutputPower(freqIdx,:) + OutputLoss(1,freqIdx); %Add outputloss as driver is measured with output attenuation
%iDrain_1TONE = iDrain(measIdx,:);



%%
% dgain = D_OutputPower - Driver_InputPower + 21;
InputPowPA_1TONE = D_OutputPower;
% Remove voltage dimension to read out power
Power_at_vds = squeeze(OutputPowerf0)
OutputPowPA_1TONE = squeeze(OutputPowerf0(1,freqIdx,:))' +OutputLoss(1,freqIdx)+fsq_dev;
Gain_1TONE = OutputPowPA_1TONE-InputPowPA_1TONE;
iDrain_1TONE = squeeze(iDrain(1,freqIdx,:))';
PAE_1TONE = 100*(10.^((OutputPowPA_1TONE-30)/10)-10.^((InputPowPA_1TONE-30)/10))./(28*iDrain_1TONE);

%%

y = 1.0*InputPowPA_1TONE(2:end)+15.1;
compression = 15.1-Gain_1TONE(2:end);

figure(1)
hold all;
plot(InputPowPA_1TONE(2:end),OutputPowPA_1TONE(2:end),'linesmooth','on');
% plot(InputPowPA_1TONE(2:end), y, 'r'); 
xlabel('Input Power (dBm)'); ylabel('Output Power (dBm)'); grid on;
title('Single-Tone Output Power at 2.4 GHz')
legend(num2str(desFreq));
% matlab2tikz('1tone_pout.tikz', 'height', '\figureheight', 'width', '\figurewidth')



figure(2)
plot(OutputPowPA_1TONE(2:end),Gain_1TONE(2:end),'linesmooth','on'); hold on;
%plot(OutputPowPA_1TONE(2:end), compression, 'r');
xlabel('Output Power (dBm)'); ylabel('Transducer Power Gain (dB)'); grid on;
title('Single-Tone Transducer Power Gain at 2.4 GHz')
plot(0,0)
% matlab2tikz('1tone_gain.tikz', 'height', '\figureheight', 'width', '\figurewidth')

figure(3)
plot(InputPowPA_1TONE(2:end),PAE_1TONE(2:end),'linesmooth','on');
hold on;
xlabel('Input Power (dBm)'); ylabel('PAE (%)'); grid on;
title('Single-Tone PAE vs. Input Power at 2.4 GHz')
% matlab2tikz('1tone_pae_vs_pin.tikz', 'height', '\figureheight', 'width', '\figurewidth')

figure(4)
plot(OutputPowPA_1TONE(2:end),PAE_1TONE(2:end),'linesmooth','on');
hold on;
xlabel('Output Power (dBm)'); ylabel('PAE (%)'); grid on;
title('Single-Tone PAE vs. Output Power at 2.4 GHz')
% matlab2tikz('1tone_pae_vs_pout.tikz', 'height', '\figureheight', 'width', '\figurewidth')

% correct_p_w = 10.^((OutputPowPA_1TONE(13,:)-30)/10);
% figure(21)
% plot(correct_p_w(13,:),(28.*iDrain_1TONE(13,:)-correct_p_w(13,:)))
%%
% 
% %close all;
% load driverPA220mA_2TONE_2_4GHz_corrected;
% load PA_200mA_2_4GHz_2TONE;
% measIdx=1;
% 
% OutputPower = OutputPower(measIdx,:);
% OutputPower_f1 = OutputPower_f1(measIdx,:);
% OutputPower_f2 = OutputPower_f2(measIdx,:);
% TOIMDl = TOIMDl(measIdx,:);
% TOIMDh = TOIMDh(measIdx,:);
% TOIMDPow_h = TOIMDPow_h(measIdx,:);
% TOIMDPow_l = TOIMDPow_l(measIdx,:);
% iDrain_2TONE = iDrain(measIdx,:);
% 
% InputPowPA_2TONE = driverOutputPower_2TONE-CircLoss;
% OutputPowPA_2TONE = OutputPower'+OutputLoss;
% Gain_2TONE = OutputPowPA_2TONE-InputPowPA_2TONE;
% ThirdOrderIMD_l = TOIMDPow_l-OutputPower_f1;
% ThirdOrderIMD_h = TOIMDPow_h-OutputPower_f2;
% iDrain_2TONE = iDrain;
% PAE_2TONE = 100*(10.^((OutputPowPA_2TONE-30)/10)-10.^((InputPowPA_2TONE-30)/10))./(28*iDrain_2TONE');
% 
% 
% figure(5)
% plot(InputPowPA_2TONE(2:end),OutputPowPA_2TONE(2:end),'linesmooth','on');
% xlabel('Input Power (dBm)'); ylabel('Output Power (dBm)'); grid on;
% title('Two-Tone Output Power at 2.4 GHz');
% % matlab2tikz('2tone_pout_vs_pin.tikz', 'height', '\figureheight', 'width', '\figurewidth')
% 
% figure(6)
% plot(InputPowPA_2TONE(2:end),Gain_2TONE(2:end),'linesmooth','on');
% xlabel('Input Power (dBm)'); ylabel('Transducer Power Gain (dB)'); grid on;
% title('Two-Tone Transducer Power Gain at 2.4 GHz');
% % matlab2tikz('2tone_gain_vs_pin.tikz', 'height', '\figureheight', 'width', '\figurewidth')
% 
% figure(7)
% plot(InputPowPA_2TONE(2:end),PAE_2TONE(2:end),'linesmooth','on');
% xlabel('Input Power (dBm)'); ylabel('PAE (%)'); grid on;
% title('Two-Tone PAE vs. Input Power at 2.4 GHz');
% % matlab2tikz('2tone__pae_vs_pin.tikz', 'height', '\figureheight', 'width', '\figurewidth')
% 
% figure(8)
% plot(InputPowPA_2TONE(2:end),ThirdOrderIMD_l(2:end),'linesmooth','on');
% hold on;
% plot(InputPowPA_2TONE(2:end),ThirdOrderIMD_h(2:end),'r','linesmooth','on');
% xlabel('Input Power (dBm)'); ylabel('Third Order IMD (dBc)'); grid on;
% title('Two-Tone Third Order IMD vs. Input Power at 2.4 GHz');
% % matlab2tikz('2tone_3IMD_vs_pin.tikz', 'height', '\figureheight', 'width', '\figurewidth')
% 
% figure(9)
% plot(OutputPowPA_2TONE(2:end),ThirdOrderIMD_l(2:end),'linesmooth','on');
% hold on;
% plot(OutputPowPA_2TONE(2:end),ThirdOrderIMD_h(2:end),'r','linesmooth','on');
% xlabel('Output Power (dBm)'); ylabel('Third Order IMD (dBc)'); grid on;
% title('Two-Tone Third Order IMD vs. Output Power at 2.4 GHz');
% % matlab2tikz('2tone__3IMD_vs_pout.tikz', 'height', '\figureheight', 'width', '\figurewidth')
% 
% % figure
% % plot(InputPowPA_2TONE(2:end),PAE_2TONE(2:end),'linesmooth','on');
% % xlabel('Input Power (dBm)'); ylabel('PAE (%)'); grid on;
% 
% 
% figure(10)
% plot(OutputPowPA_2TONE,PAE_2TONE,'linesmooth','on');
% xlabel('Output Power (dBm)'); ylabel('PAE (%)'); grid on;
% title('Two-Tone PAE vs. Output Power at 2.4 GHz');
% % matlab2tikz('2tone_pout.tikz', 'height', '\figureheight', 'width', '\figurewidth')
% 
% %
% clc;
% %close all;
% 
% [dummy idx] = min((InputPowPA_1TONE-28).^2);
% 
% str = sprintf('Measurement frequency: %0.3g GHz',desFreq);
% disp(str)
% str = sprintf('Single-tone performance at 28 dBm input power');
% disp(str)
% str = sprintf('Output power: %0.3g dBm',OutputPowPA_1TONE(idx));
% disp(str)
% str = sprintf('Gain: %0.3g dB',Gain_1TONE(idx));
% disp(str)
% str = sprintf('PAE: %0.3g %%',PAE_1TONE(idx));
% disp(str)
% 
% [dummy idx] = min((OutputPowPA_2TONE-40).^2);
% 
% str = sprintf('Two-tone performance at 40 dBm output power (two-tone)');
% disp(str)
% str = sprintf('Gain: %0.3g dB',Gain_2TONE(idx));
% disp(str)
% str = sprintf('PAE: %0.3g %%',PAE_2TONE(idx));
% disp(str)
% str = sprintf('Third Order IMD (low): %0.3g dBc',ThirdOrderIMD_l(idx));
% disp(str)
% str = sprintf('Third Order IMD (high): %0.3g dBc',ThirdOrderIMD_h(idx));
% disp(str)
% str = sprintf('Generator output power: %0.3g dBm',InputPower(idx));
% disp(str)