close all; 
clc; clear all;
load AB_passiveloss;
load AB_driverPA_440mA;
load AB_PA_160ma_freqs;


desFreq = 2.400;
freqs = RFfreq;
[dummy freqIdx] = min((freqs-desFreq).^2);
% [dummy voltIdx] = min((vd-desVolt).^2);



CircLoss = 0.48; %Not used, circulator incorporated in driver ouput.
fsq_dev = 0.2; % FSQ off by 0.2 dB
OutputLoss = [20.7458] + fsq_dev-0.04;%passive loss adjusted for FSQ deviation and SMU deviation




% measIdx = 2;
D_OutputPower = Driver_OutputPower(freqIdx,:) + OutputLoss + fsq_dev;%(1,freqIdx); %Add outputloss as driver is measured with output attenuation
%iDrain_1TONE = iDrain(measIdx,:);

corrected_pout_vd = zeros(length(vd), length(OutputPowerf0(1,1,:)));
corrected_gain_vd = zeros(length(vd), length(OutputPowerf0(1,1,:)));
corrected_pae_vd = zeros(length(vd), length(OutputPowerf0(1,1,:)));

vd_const_gain = zeros(1,length(vd));
for voltIdx=1:length(vd)
    %%
    % dgain = D_OutputPower - Driver_InputPower + 21;
    InputPowPA_1TONE = D_OutputPower;
    % Remove voltage dimension to read out power
    OutputPowPA_1TONE = squeeze(OutputPowerf0(voltIdx,freqIdx,:))' +OutputLoss+fsq_dev;
    Gain_1TONE = OutputPowPA_1TONE-InputPowPA_1TONE;
    iDrain_1TONE = squeeze(iDrain(voltIdx,freqIdx,:))';
    PAE_1TONE = 100*(10.^((OutputPowPA_1TONE-30)/10)-10.^((InputPowPA_1TONE-30)/10))./(vd(voltIdx)*iDrain_1TONE);
    
    %%
    
    y = 1.0*InputPowPA_1TONE(2:end)+15.1;
    compression = 15.1-Gain_1TONE(2:end);
    
    figure(1)
    plot(InputPowPA_1TONE(2:end),OutputPowPA_1TONE(2:end),'linesmooth','on'); hold on
%     plot(InputPowPA_1TONE(2:end), y, 'r');
    xlabel('Input Power (dBm)'); ylabel('Output Power (dBm)'); grid on;
    title('Single-Tone Output Power at 2.4 GHz')
    % matlab2tikz('1tone_pout.tikz', 'height', '\figureheight', 'width', '\figurewidth')
    hold on
    
    
    
    figure(2)
    [dummy constIdx] = min((Gain_1TONE-9).^2);
    vd_const_gain(voltIdx) = OutputPowPA_1TONE(constIdx);
    plot(OutputPowPA_1TONE(2:end),Gain_1TONE(2:end),'linesmooth','on'); hold on;
    %plot(OutputPowPA_1TONE(2:end), compression, 'r');
    xlabel('Output Power (dBm)'); ylabel('Transducer Power Gain (dB)'); grid on;
    title('Single-Tone Transducer Power Gain at 2.4 GHz')
    % matlab2tikz('1tone_gain.tikz', 'height', '\figureheight', 'width', '\figurewidth')
    hold on
    
%     figure(3)
%     plot(InputPowPA_1TONE(2:end),PAE_1TONE(2:end),'linesmooth','on');
%     xlabel('Input Power (dBm)'); ylabel('PAE (%)'); grid on;
%     title('Single-Tone PAE vs. Input Power at 2.4 GHz')
%     % matlab2tikz('1tone_pae_vs_pin.tikz', 'height', '\figureheight', 'width', '\figurewidth')
%     hold on
    
    figure(4)
    plot(OutputPowPA_1TONE(2:end),PAE_1TONE(2:end),'linesmooth','on');
    xlabel('Output Power (dBm)'); ylabel('PAE (%)'); grid on;
    title('Single-Tone PAE vs. Output Power at 2.4 GHz')
    
    % matlab2tikz('1tone_pae_vs_pout.tikz', 'height', '\figureheight', 'width', '\figurewidth')
    hold on
    
    corrected_pout_vd(voltIdx,:) = OutputPowPA_1TONE;
    corrected_gain_vd(voltIdx,:) = Gain_1TONE;
    corrected_pae_vd(voltIdx,:) = PAE_1TONE;
end
%     vd_corr = vd;
% save('corrected_variables_vd','vd_corr', 'corrected_pout_vd', 'corrected_gain_vd', 'corrected_pae_vd')
% figure(4)
% plot(OutputPowPA_1TONE(2:end), nyfunc(2:end),'r', 'linesmooth','on')
% ylim([0 80])

figure(1)
xlim([12 34]);
ylim([0 42])
% matlab2tikz('1tone_pout_freq.tikz', 'height', '\figureheight', 'width', '\figurewidth')
figure(2)
xlim([20 42]);
ylim([0 15])
% matlab2tikz('1tone_gt_freq.tikz', 'height', '\figureheight', 'width', '\figurewidth')
% figure(3)
% xlim([15 45]);
% axis tight;
% matlab2tikz('1tone_pae_in_vd.tikz', 'height', '\figureheight', 'width', '\figurewidth')
figure(4)
xlim([20 42]);
ylim([0 70])
% matlab2tikz('1tone_pae_out_freq.tikz', 'height', '\figureheight', 'width', '\figurewidth')


%% Two tone

close all;
load driverPA220mA_2TONE_2_4GHz;
%correcting driver
loss = OutputLoss;
driverOutputPower_2TONE = OutputPower' + loss + fsq_dev;
driverOutputPOwerf1_2TONE = OutputPower_f1' + loss;
driverOutputPOwerf2_2TONE = OutputPower_f2' + loss;
driverTOIMDPow_l_2TONE = TOIMDPow_l' + loss;
driverTOIMDPow_h_2TONE = TOIMDPow_h' + loss;

load AB_PA_160mA_2_4GHz_2TONE_no_noise;
measIdx=1;

OutputPower = OutputPower(measIdx,:) + fsq_dev;
OutputPower_f1 = OutputPower_f1(measIdx,:);
OutputPower_f2 = OutputPower_f2(measIdx,:);
TOIMDl = TOIMDl(measIdx,:);
TOIMDh = TOIMDh(measIdx,:);
TOIMDPow_h = TOIMDPow_h(measIdx,:);
TOIMDPow_l = TOIMDPow_l(measIdx,:);
iDrain_2TONE = iDrain(measIdx,:);

InputPowPA_2TONE = driverOutputPower_2TONE;
OutputPowPA_2TONE = OutputPower'+OutputLoss+fsq_dev;
Gain_2TONE = OutputPowPA_2TONE-InputPowPA_2TONE;
ThirdOrderIMD_l = TOIMDPow_l-OutputPower_f1;
ThirdOrderIMD_h = TOIMDPow_h-OutputPower_f2;
iDrain_2TONE = iDrain;
PAE_2TONE = 100*(10.^((OutputPowPA_2TONE-30)/10)-10.^((InputPowPA_2TONE-30)/10))./(28*iDrain_2TONE');


figure(5)
plot(InputPowPA_2TONE(2:end),OutputPowPA_2TONE(2:end),'linesmooth','on');
xlabel('Input Power (dBm)'); ylabel('Output Power (dBm)'); grid on;
title('Two-Tone Output Power at 2.4 GHz');
xlim([12 34]);
ylim([0 42])
% matlab2tikz('2tone_pout_vs_pin.tikz', 'height', '\figureheight', 'width', '\figurewidth')

figure(6)
plot(OutputPowPA_2TONE(2:end),Gain_2TONE(2:end),'linesmooth','on');
xlabel('Output Power (dBm)'); ylabel('Transducer Power Gain (dB)'); grid on;
title('Two-Tone Transducer Power Gain at 2.4 GHz');
xlim([20 42]);
ylim([0 15]);
% matlab2tikz('2tone_gain_vs_pin.tikz', 'height', '\figureheight', 'width', '\figurewidth')

% figure(7)
% plot(InputPowPA_2TONE(2:end),PAE_2TONE(2:end),'linesmooth','on');
% xlabel('Input Power (dBm)'); ylabel('PAE (%)'); grid on;
% title('Two-Tone PAE vs. Input Power at 2.4 GHz');
% matlab2tikz('2tone__pae_vs_pin.tikz', 'height', '\figureheight', 'width', '\figurewidth')

% figure(8)
% plot(InputPowPA_2TONE(2:end),ThirdOrderIMD_l(2:end),'linesmooth','on');
% hold on;
% plot(InputPowPA_2TONE(2:end),ThirdOrderIMD_h(2:end),'r','linesmooth','on');
% xlabel('Input Power (dBm)'); ylabel('Third Order IMD (dBc)'); grid on;
% title('Two-Tone Third Order IMD vs. Input Power at 2.4 GHz');
% matlab2tikz('2tone_3IMD_vs_pin.tikz', 'height', '\figureheight', 'width', '\figurewidth')

figure(9)
plot(OutputPowPA_2TONE(2:end),ThirdOrderIMD_l(2:end),'linesmooth','on');
hold on;
plot(OutputPowPA_2TONE(2:end),ThirdOrderIMD_h(2:end),'r','linesmooth','on');
xlabel('Output Power (dBm)'); ylabel('Third Order IMD (dBc)'); grid on;
title('Two-Tone Third Order IMD vs. Output Power at 2.4 GHz');
xlim([20 42]);
ylim([-40 0]);
% matlab2tikz('2tone__3IMD_vs_pout.tikz', 'height', '\figureheight', 'width', '\figurewidth')

% figure
% plot(InputPowPA_2TONE(2:end),PAE_2TONE(2:end),'linesmooth','on');
% xlabel('Input Power (dBm)'); ylabel('PAE (%)'); grid on;


figure(10)
plot(OutputPowPA_2TONE,PAE_2TONE,'linesmooth','on');
xlabel('Output Power (dBm)'); ylabel('PAE (%)'); grid on;
title('Two-Tone PAE vs. Output Power at 2.4 GHz');
xlim([20 42]);
ylim([0 70]);
% matlab2tikz('2tone_pout.tikz', 'height', '\figureheight', 'width', '\figurewidth')

%
clc;
%close all;
% 
% [dummy idx] = min((InputPowPA_1TONE-28).^2);
% 
% str = sprintf('Measurement frequency: %0.3g GHz',desFreq);
% disp(str)
% str = sprintf('Single-tone performance at 28 dBm input power');
% disp(str)
% str = sprintf('Output power: %0.3g dBm',OutputPowPA_1TONE(idx));
% disp(str)
% str = sprintf('Gain: %0.3g dB',Gain_1TONE(idx));
% disp(str)
% str = sprintf('PAE: %0.3g %%',PAE_1TONE(idx));
% disp(str)
% 
% [dummy idx] = min((OutputPowPA_2TONE-40).^2);
% 
% str = sprintf('Two-tone performance at 40 dBm output power (two-tone)');
% disp(str)
% str = sprintf('Gain: %0.3g dB',Gain_2TONE(idx));
% disp(str)
% str = sprintf('PAE: %0.3g %%',PAE_2TONE(idx));
% disp(str)
% str = sprintf('Third Order IMD (low): %0.3g dBc',ThirdOrderIMD_l(idx));
% disp(str)
% str = sprintf('Third Order IMD (high): %0.3g dBc',ThirdOrderIMD_h(idx));
% disp(str)
% str = sprintf('Generator output power: %0.3g dBm',InputPower(idx));
% disp(str)